%Ruy_Tc_P09_b.m
%Calcula Ruy para diferentes largos de las seales usando xcorr de MATLAB
%
%TF=3000
format compact
clear all
close all

%Tc=9.49 para b=1 y a =0.9

TF=30000*9.49 % Largo de los datos (1 a TF)

a=0.90

b=1

%Genera los datos de la planta
GenDat=1;

if GenDat==1
    y=zeros(TF,1);ysr=zeros(TF,1);u=zeros(TF,1);w=zeros(TF,1);n=zeros(TF,1);
    c1=0.8;c2=0.5;
    w=randn(TF,1);
    h=zeros(TF,1);
    u=w; % u es ruido blanco  
    for i=2:TF
        y(i)=a*y(i-1)+b*u(i-1);
    end 
end

%Constante de tiempo del sistema: tiempo que toma que la respuesta h
%caiga a e^-1.
%a^kc = e^(-1)                  

Tc=-1/log(a)

%4Tc=4*Tc;


%La resouesta repuesta del sistema al pulso unitario es Ruy si la entrada u es ruido
%blanco de varianza 1.

MAXLAG=150;% Maximo retardo para determinar Ruy
h=zeros(1:MAXLAG,1);

for i=1:MAXLAG
        h(i)=b*a^(i-1);% Respuesta del sistema al pulso unitario calculada tericcamente
end

figure;plot(h(1:MAXLAG));legend('h');title('Respuesta de y(i)=a*y(i-1)+b*u(i-1) al pulso unitario')
grid;xlabel(['Cte. de tiempo Tc= ',num2str(Tc)])

figure;plot(h(1:round(MAXLAG/10)));legend('h');title('Respuesta de y(i)=a*y(i-1)+b*u(i-1) al pulso unitario')
grid;xlabel(['Cte. de tiempo Tc= ',num2str(Tc)])

%Calcula Ruy
%Como u = w es ruido blanco, se debe tener que h = Ruy.
r=round(TF/Tc);

[Ruy LAGS]=xcorr(y,u, MAXLAG,'unbiased');
figure;plot(LAGS,Ruy,'r*')
legend('Ruy')
xlabel(['TF=',num2str(TF),';     Cte. de tiempo Tc= ',num2str(Tc),';   TF=',num2str(r),'*Tc'])
grid

hold %matiene el grafico anterior y hace plot encima
plot(h(1:MAXLAG),'b-')
hold off
title('Ruy y h (respuesta al pulso unitario del sistema)')



%Funcion de autocorrelacion de ruido blanco.

[Rww LAGS]=xcorr(w, MAXLAG,'unbiased');
figure;plot(LAGS,Rww,'m*');legend('Rww');xlabel(['TF=',num2str(TF)]);grid;
title('Rww del ruido blanco discreto w')